#!/usr/bin/python
# coding: utf-8

##
## Autor rozwiązania: Jan Palimąka
##

lista_wektorow = []

while True:
	
	print '\n***************Menu***************'
	print '0:  Wyjście z programu.'
	print '1:  Dodaj wektor do bazy.'
	print '2:  Usuń wektor z bazy.'
	print '3:  Wykonaj działania na wektorach.'
	print '4:  Wyświetl wektory'
	
	wybor = int(raw_input('\n>>>'))
	
	if wybor == 0:
		exit()

#####################################################################	
# dodanie wektora do listy
#
	elif wybor == 1:	
		print '\nWpisuj liczby, które mają być zapisane w wektorze.'
		print 'Aby zapisać liczby z częścią ułamkową, używaj kropki zamiast przecinka'
		print 'Aby zakończyć wpisywanie naciśnij Enter.'
		print '\nUwaga: pusty wektor nie zostanie zapisany do bazy.'
		
		tmp_wek = []
		
		while True:
			print '\nWektor obecnie wygląda tak:', tmp_wek
			tmp = raw_input('Wpisz liczbę nr ' + str(len(tmp_wek) + 1) + ' lub naciśnij Enter: ')
			if len(tmp) == 0:
				break
			
			tmp_wek.append(float(tmp))
		
		if len(tmp_wek) != 0:
			lista_wektorow.append(tmp_wek)
			print '\nWektor został wpisany pod numerem ' + str(len(lista_wektorow) - 1) + '.'
		else:
			print '\nWektor nie został zapisany.'

#####################################################################		
# usuwanie wektora
#
	elif wybor == 2:	
		rozmiar = len(lista_wektorow)
		if rozmiar == 0:
			print '\nBrak obecnie dostępnych wektorow.'
		else:
			print '\nObecnie dostępne wektory: ' + str(rozmiar) + '\n'
			print 'nr\tzawartość'
			for i in range(0, rozmiar):
				print str(i) + '.\t', lista_wektorow[i]
			
			index = int(raw_input('\nKtóry wektor usunąć?: '))
			
			if index < 0 or index >= rozmiar:
				print 'Niepoprawny indeks wektora.'
			else:
				print 'Usunięto wektor ', lista_wektorow[index]
				lista_wektorow.remove(lista_wektorow[index])

#####################################################################		
# działania na wektorach
#
	elif wybor == 3:
		rozmiar = len(lista_wektorow)
		if rozmiar == 0:
			print '\nBrak obecnie dostępnych wektorow.'
		else:
			arg1 = 0
			arg2 = 0

			print '\nnr\tzawartość'
			for i in range(0, rozmiar):
				print str(i) + '.\t', lista_wektorow[i]
			
			while True:
				arg1 = int(raw_input('\nWybierz pierwszy wektor (wpisz liczbę porządkową): '))
				if arg1 in range(0, rozmiar):
					break
				print 'Podany wektor nie istnieje, spróbuj ponownie.'
			
			print '\nWybierz działanie do wykonania lub Enter, aby przerwać.'
			print 'Możliwe działania to: +, -, *, /, # (iloczyn skalarny).'
			while True:
				dzialanie = raw_input('Co wybierasz?: ')
				if dzialanie in ['+', '-', '*', '/', '#', '']:
					break
				print 'Spróbuj ponownie wybrać poprawne działanie.'
			
			if dzialanie == '':
				continue
				
			print '\nWektor będący drugim składnikiem musi mieć tą samą długość.'
			print 'Poniżej ich lista:\n'
			print 'nr\tzawartość'
			for i in range(0, rozmiar):
				if len(lista_wektorow[i]) == len(lista_wektorow[arg1]):
					print str(i) + '.\t', lista_wektorow[i]
			
			print ''
			
			while True:
				arg2 = int(raw_input('Wybierz drugi wektor (wpisz liczbę porządkową): '))
				if arg2 in range(0, rozmiar) and len(lista_wektorow[arg2]) == len(lista_wektorow[arg1]):
					break
				print 'Podany wektor nie istnieje lub ma nieodpowiednią długość, spróbuj ponownie.'
			
			#działania matematyczne
			tmp_wek = []
			
			if dzialanie == '+':
				for i in range(0, len(lista_wektorow[arg1])):
					tmp_wek.append(lista_wektorow[arg1][i] + lista_wektorow[arg2][i])

			elif dzialanie == '-':
				for i in range(0, len(lista_wektorow[arg1])):
					tmp_wek.append(lista_wektorow[arg1][i] - lista_wektorow[arg2][i])

			elif dzialanie == '*':
				for i in range(0, len(lista_wektorow[arg1])):
					tmp_wek.append(lista_wektorow[arg1][i] * lista_wektorow[arg2][i])

			elif dzialanie == '/':
				for i in range(0, len(lista_wektorow[arg1])):
					tmp_wek.append(lista_wektorow[arg1][i] / lista_wektorow[arg2][i])

			else:	# iloczyn skalarny
				tmp = 0.0
				for i in range(0, len(lista_wektorow[arg1])):
					tmp += lista_wektorow[arg1][i] * lista_wektorow[arg2][i]
				tmp_wek.append(tmp)
			
			#wyświetlenie wyniku
			print lista_wektorow[arg1], dzialanie, lista_wektorow[arg2], '=', tmp_wek
			
			dzialanie = raw_input('\nZapisać wynik w bazie? (t/n): ')
			
			if dzialanie == 't':
				lista_wektorow.append(tmp_wek)
				print '\nWektor zosatał zapisany w bazie pod nr.', len(lista_wektorow) - 1

#####################################################################
# wyswietlanie dostępnych wektorów
#
	elif wybor == 4:	
		rozmiar = len(lista_wektorow)
		if rozmiar == 0:
			print '\nBrak obecnie dostępnych wektorow.'
		else:
			print '\nObecnie dostępne wektory: ' + str(rozmiar) + '\n'
			print 'nr\tzawartość'
			for i in range(0, rozmiar):
				print str(i) + '.\t', lista_wektorow[i]

#####################################################################
#
	else:
		print 'Zły wybór, spróbuj ponownie.'

